#!/usr/bin/perl

use strict;
use vars qw/%ZENR/;

#proxy (for &SendScout)
chomp(my $proxy = `cat /etc/netpkg.conf|grep ^Proxy_Socket`);
$proxy =~ m/Proxy_Socket\s*=\s*(http:\/\/)(.*)/;
$proxy = $2;
$ENV{http_proxy} = "http://$proxy" if ($proxy);

chomp(my $type = shift);
chomp(my $init = shift);

sub SendScout {
        my $mode = shift;
        if ($mode eq 'init' || ! -e "/etc/zenrmpkg.conf") {
		print "Initializing ...\n";
		unlink "/etc/zenrmpkg.conf";
		# generating repo list from /etc/netpkg.conf
		chomp(my @in = `grep -i -E "Internet_mirror.*" /etc/netpkg.conf`);

		my @types = qw/current snapshot/;
		foreach(@types){
			my $type = $_;
			my @list = map($_ =~ /http:\/\/(.*)\/$type/, @in);

			for my $i (0 ... $#list){
				print "\($i\) $list[$i]\n";
			};

			print "Please choose a $type repo to fetch from:";
			chomp(my $pick = <STDIN>);
			$pick = int($pick);#save us a lot of troubles ...
		
			my $repo = $list[$pick];
			system("echo \"\\\$ZENR{$type} = \'$repo\';\" >> /etc/zenrmpkg.conf");

			print "Fetching $type ......";
	                system("GET http://$repo/$type/PACKAGES.TXT.gz 1> /tmp/PACKAGES.$type.gz") || print "Done\n";
			system("/usr/libexec/mkdepfile.sh $type") && die "not good!\n";
		}
		return "\nALL OK!\n";
        }else{
		require "/etc/zenrmpkg.conf";

		my $last;
		unless(%ZENR){
			print "Please use -u option to configure repo list!\n";
			$last = "distro.ibiblio.org\/pub\/linux\/distributions\/zenwalk\/i486";
		}else{
			$last = $ZENR{$type};
		}

		my $repo = "http:\/\/$last\/$type";
		print "Fetching $type ...\n";
                system("GET -i /tmp/PACKAGES.$type.gz $repo/PACKAGES.TXT.gz 1> /tmp/PT.gz") or (system("mv /tmp/PT.gz /tmp/PACKAGES.$type.gz"));
		unlink "/tmp/PT.gz";
		system("/usr/libexec/mkdepfile.sh $type") && die "not good!\n";
		return "PACKAGE.TXT updated\n";
        }

}

print &SendScout($init),"\n";
